unit domtree;

interface

type
    buf=-1..1000;
    tip=-1..5;
    elem=record
        szint: 0..4;
        text: string[80];
        tipus: tip;
    end;
var
    dom: array[buf] of elem;
    dh: buf;
    link: array[buf] of string;
    lh: buf;

function parse(s: string): boolean;

implementation

function mennyi(s: string; t: char): byte;
var
    i: byte;
begin
    i:=1;
    while s[i]=t do inc(i);
    mennyi:=i-1;
end;

procedure sor(s: string; sz: byte);
var
    t: string;
    p: integer;
begin
    // egy sor beolvasasa
    p:=pos('[', s);
    while (p>0) do begin
        t:=copy(s, 1, p-1);
        if t<>'' then begin
            dom[dh].szint:=sz;
            dom[dh].tipus:=0;
            dom[dh].text:=t;
            inc(dh);
        end;
        s:=copy(s, p+1, length(s));
        p:=pos(']', s);
        if s[1]='a' then begin
            t:=copy(s, 7, p-7);
            link[lh]:=t;
            inc(lh);
            s:=copy(s, p+1, length(s));
            p:=pos('[', s);
            t:=copy(s, 1, p-1);
            dom[dh].szint:=sz;
            dom[dh].tipus:=1;
            dom[dh].text:=t;
            inc(dh);
            s:=copy(s, p+4, length(s));
        end else if s[1]='i' then begin
            t:=copy(s, 9, p-10);
            dom[dh].szint:=sz;
            dom[dh].tipus:=3;
            dom[dh].text:=t;
            inc(dh);
            s:=copy(s, p+1, length(s));
        end;
        p:=pos('[', s);

    end;
    if s<>'' then begin
        dom[dh].szint:=sz;
        dom[dh].tipus:=0;
        dom[dh].text:=s;
        inc(dh);
    end;
end;

function parse(s: string): boolean;
var
    f: text;
    t: string;
    szint: 0..4;
    tipus: tip;
    j: integer;
begin
    // a DOM-fa felepitese
    dom[-1].szint:=0;
    dom[-1].tipus:=-1;
    dh:=0;
    lh:=0;
    assign(f, s);
    {$I-}
    reset(f);
    {$I+}
    if ioresult<>0 then
        parse:=false
    else begin
        while not eof(f) do begin
            readln(f, t);
            szint:=mennyi(t, '*');
            tipus:=0;
            if szint=0 then begin
                szint:=mennyi(t, '#');
                if (szint>0) then tipus:=4;
            end else tipus:=5;
            if (t='') then begin
                szint:=0;
                tipus:=0;
            end;
            for j:=dom[dh-1].szint+1 to szint-1 do begin
                dom[dh].szint:=j-1;
                dom[dh].tipus:=tipus;
                inc(dh);
            end;
            if (tipus>3) then begin
                dom[dh].szint:=szint-1;
                dom[dh].tipus:=tipus;
                inc(dh);
                t:=copy(t, szint+1, length(t));
            end;
            sor(t, szint);
            dom[dh].szint:=szint;
            dom[dh].tipus:=2;
            inc(dh);
        end;
        close(f);
        parse:=true;
    end;
end;

begin
end.
