program wiki;

uses kepkezelo,domtree,crt,windows;

var fajlNev:string;
var kilep:boolean;
var sor:integer;
var sorszam: array[0..20] of integer;

const T_TEXT = 0;
const T_AREF =1;
const T_NL = 2;
const T_IMG = 3;
const T_NUM = 4;
const T_LIST = 5;

const tnev: array[0..5] of string = ('text','a ref','newline','image','numbered','list');

procedure scroll;
begin
    gotoxy(1,21);
    writeln('Van meg tovabb is! Nyomjon ENTERT!');
    readkey;
end;

procedure ujsor;
begin
    sor:=sor+1;
    if(sor>20)then
    begin
        scroll;
        clrscr;
        sor:=1;
    end;
    writeln();
end;

procedure sorszamNullaz(honnan:integer);
var i:integer;
begin
    for i:=honnan to 2 do
    begin
        sorszam[i] := 0;
    end;
end;

procedure kiir;
var i,j,k:integer;
var kep:string[255];
var kep2:string[255];
begin
    // a felepitett DOM-fa alapjan generaljuk az oldalt
    clrscr;
    sor:=1;
    sorszamNullaz(0);
    for i:=0 to dh-1 do
    begin
        if(dom[i].tipus = T_NUM) then
        begin
            sorszamNullaz(dom[i].szint + 1);
        end
        else
        begin
            sorszamNullaz(dom[i].szint);
        end;
        if( dom[i].tipus =  T_TEXT) then
        begin
            write(dom[i].text);
        end
        else if(dom[i].tipus = T_NL) then
        begin
            ujsor;
        end
        else if(dom[i].tipus = T_LIST) then
        begin
            if (i< dh-1) and (dom[i+1].tipus = T_LIST) then
            begin
                continue;
            end;
            for j:=0 to dom[i].szint-1 do
            begin
                write(' ');
            end;
            write('- ');
        end
        else if(dom[i].tipus = T_AREF) then
        begin
            highvideo;
            textcolor(LIGHTGREEN);
            write(' ',dom[i].text,' ');
            normvideo;
            textcolor(WHITE);
        end
        else if(dom[i].tipus = T_NUM) then
        begin
            sorszam[dom[i].szint]:=sorszam[dom[i].szint]+1;
            for j:=0 to dom[i].szint do
            begin
                write(sorszam[j],'.');
            end;
            write(' ');
        end
        else if(dom[i].tipus = T_IMG) then
        begin
            ujsor;
            kep2:='';
            kep2:=kepszamol(dom[i].text);
            if(keposzlop >= 20-sor ) then
            begin
                scroll;
                clrscr;
                sor:=1;
            end;
            while length(kep2)>kepsor do
            begin
                write(copy(kep2,1,kepsor));
                ujsor;
                kep2:=copy(kep2,kepsor+1,length(kep2));
            end;
        end;
    end;
end;

procedure parancsBeker; forward;

procedure nincsFajl;
begin
    clrscr;
    gotoxy(1,21);
    writeln(fajlNev,' :ilyen fajl nem letezik! Nyomj ENTERT!');
    fajlNev:='index.txt';
    readln;
    clrscr;
end;

procedure nincsLink;
begin
    clrscr;
    gotoxy(1,21);
    writeln('Ilyen link nincs! Nyomj ENTERT!');
    readln;
end;

procedure domKiirva;
begin
    clrscr;
    gotoxy(1,21);
    writeln('Dom kiirva! Nyomj ENTERT!');
    readln;
end;

procedure rosszParancs;
begin
    clrscr;
    gotoxy(1,21);
    writeln('Ilyen parancs nincs! Igyal egy SORT!');
    readln;
end;

procedure domkiir;
var df: text;
var i,j,k:integer;
var linknum:integer;
begin
    // a DOM-fa kiirasa fajba
    linknum:=0;
    assign(df, 'dom'+fajlNev);
    rewrite(df);
    writeln(df, 'page');
    for i:=0 to dh-1 do
    begin
        write(df, '|');
        for j:=0 to dom[i].szint -1 do
        begin
            write(df, '   |');
        end;
        writeln(df);
        write(df, '|');
        for j:=0 to dom[i].szint-1 do
        begin
            write(df, '   |');
        end;
        write(df,'-', tnev[dom[i].tipus]);
        if(dom[i].tipus =T_AREF)
            or (dom[i].tipus = T_TEXT)
            or (dom[i].tipus = T_IMG)
        then
        begin
            write(df,':');
        end;
        if (dom[i].tipus <> T_IMG) then
        begin
            write(df,dom[i].text);
        end
        else
        begin
            write(df, '[', dom[i].text,']');
        end;
        if(dom[i].tipus = T_AREF) then
        begin
            write(df, '[', link[linknum],']');
            linknum:=linknum+1;
        end;
        writeln(df);
    end;
    close(df);
end;

procedure parancsBeker;
var parancs:string;
var str:string;
var num:integer;
var err:word;
begin
    // a felhasznaloi bemenet kezelese
    gotoxy(1,21);
    writeln('Mit parancsolsz? (sNev lN d q)');
    readln(parancs);
    if( (parancs[1] = 's') or (parancs[1] = 'S')) then
    begin
        fajlNev := copy(parancs, 2, 255) + '.txt';
    end
    else
    if( (parancs[1] = 'l') or (parancs[1] = 'L')) then
    begin
        str := copy(parancs, 2, 255);
        num := 255;
        val(str,num,err);
        num:=num-1;
        if (err <> 0 ) or (num >= lh) or (num <0 ) then
        begin
            nincsLink;
        end
        else
        begin
            fajlnev := link[num];
        end;
    end
    else
    if( (parancs[1] = 'd') or (parancs[1] = 'D')) then
    begin
        domkiir();
        domkiirva();
    end
    else
    if( (parancs[1] = 'q') or (parancs[1] = 'Q')) then
    begin
        kilep:=true;
    end
    else
    begin
        rosszParancs;
    end;
end;

begin
    SetConsoleTitle('SorWiki');
    fajlNev:='index.txt';
    kilep :=false;
    while not kilep do
    begin
        clrscr;
        if(parse(fajlnev)) then
        begin
            kiir();
        end
        else
        begin
            nincsFajl;
        end;
        parancsBeker();
    end;
end.
